"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const RoteadorRetangulo_1 = __importDefault(require("./roteador/RoteadorRetangulo"));
const RoteadorQuadrado_1 = __importDefault(require("./roteador/RoteadorQuadrado"));
class Servidor {
    constructor() {
        //todos os atributos da classe servidor devem ser privados
        //tipicamente em typescript os atributos começam com _
        this._porta = 3000;
        this._host = "localhost";
        this._app = (0, express_1.default)();
    }
    //método que inicia o servidor
    iniciar() {
        this._app.use(express_1.default.json());
        this._app.use(express_1.default.urlencoded({ extended: true }));
        //inincia as rotas
        this.iniciarRotas();
        this.run();
    }
    iniciarRotas() {
        //cria umma instancia para cada roteador.
        let roteadorQuadrado = new RoteadorQuadrado_1.default();
        let roteadorRetangulo = new RoteadorRetangulo_1.default();
        this._app.use("/quadrados/", roteadorQuadrado.getRotas());
        this._app.use("/retangulos/", roteadorRetangulo.getRotas());
    }
    run() {
        this._app.listen(this._porta, this._host, function () {
            console.log("Servidor rodando...");
        }).on("error", (err) => {
            console.log("Erro ao inicializar o sercidor");
            console.error(err);
        });
    }
}
exports.default = Servidor;
