"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = require("express");
const calcularArea_1 = require("../controlador/quadrado/calcularArea");
const calcularPerimetro_1 = require("../controlador/quadrado/calcularPerimetro");
const calcularDiagonal_1 = require("../controlador/quadrado/calcularDiagonal");
class RotasQuadrado {
    constructor() {
        this._roteador = (0, express_1.Router)();
    }
    getRotas() {
        //trata a rota /quadrados/areas/numero chamando o controle correspondente 
        this._roteador.get("/areas/:lado/", calcularArea_1.calcularArea);
        //trata a rota /quadrados/perimetros/numero chamando o controle correspondente 
        this._roteador.get("/perimetros/:lado/", calcularPerimetro_1.calcularPerimetro);
        //trata a rota /quadrados/diagonais/numero chamando o controle correspondente 
        this._roteador.get("/diagonais/:lado/", calcularDiagonal_1.calcularDiagonal);
        return this._roteador;
    }
}
exports.default = RotasQuadrado;
