import Express, { Application } from "express";
import RoteadorRetangulo from "./roteador/RoteadorRetangulo";
import RoteadorQuadrado from "./roteador/RoteadorQuadrado";

export default class Servidor  {
  //todos os atributos da classe servidor devem ser privados
  //tipicamente em typescript os atributos começam com _
  private _porta: number = 3000;
  private _host: string = "localhost";
  private _app: Application = Express();
  //método que inicia o servidor
  public iniciar():void{
    this._app.use(Express.json());
    this._app.use(Express.urlencoded({ extended: true }));
    //inincia as rotas
    this.iniciarRotas();
    this.run();
  }
  private iniciarRotas():void {
    //cria umma instancia para cada roteador.
    let roteadorQuadrado = new RoteadorQuadrado();
    let roteadorRetangulo = new RoteadorRetangulo();
    this._app.use("/quadrados/", roteadorQuadrado.getRotas());
    this._app.use("/retangulos/", roteadorRetangulo.getRotas());
  }
  private run():void {
    //roda a aplicação express. 
    this._app.listen(this._porta, this._host, function () {
      console.log("Servidor rodando...");
    }).on("error", (err: any) => {
        console.log("Erro ao inicializar o sercidor");
        console.error(err);
  
    });
  }
}