import { Request, Response } from "express";
import Quadrado from "../../modelo/Quadrado"

//controle responsavel pela rota /quadrado/areas/:lado
export function controleCalcularArea(request: Request, response: Response): Response {

  //recupera o lado que veio como parametro na url.
  let lado: number = parseFloat(request.params.lado);

  let q = new Quadrado();
  q.lado = lado;

  const objetoJsonResposta = { 
      area: q.calcularArea() 
  };
  
  return response.json(objetoJsonResposta);
}