import { Router } from "express";
import { controleCalcularArea } from "../controlador/quadrado/controleCalcularArea";
import { controleCalcularPerimetro } from "../controlador/quadrado/controleCalcularPerimetro";
import { controleCalcularDiagonal } from "../controlador/quadrado/controleCalcularDiagonal";

export default 
class RotasQuadrado  {
  private _roteador = Router();

  public getRotas(): Router {
    //trata a rota /quadrados/areas/numero chamando o controle correspondente 
    this._roteador.get("/areas/:lado/", controleCalcularArea); 
     //trata a rota /quadrados/perimetros/numero chamando o controle correspondente 
    this._roteador.get("/perimetros/:lado/", controleCalcularPerimetro); 
    //trata a rota /quadrados/diagonais/numero chamando o controle correspondente 
    this._roteador.get("/diagonais/:lado/", controleCalcularDiagonal);    
    return this._roteador;
  }

}

