"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.controle_create = void 0;
const Cargo_1 = __importDefault(require("../../modelo/Cargo"));
const JwtToken_1 = __importDefault(require("../../modelo/JwtToken"));
function controle_create(request, response) {
    const dadosAutorizacao = request.headers.authorization;
    if (dadosAutorizacao !== undefined) {
        const jwt = new JwtToken_1.default();
        const validacao = jwt.validarToken(dadosAutorizacao);
        console.log(validacao);
        if (validacao.status == true) {
            console.log("validou toketn");
            const nomeCargo = request.body.nomeCargo;
            const cargo = new Cargo_1.default();
            cargo.nomeCargo = nomeCargo;
            cargo.create().then(value => {
                const obj = value;
                const resposta = {
                    status: true,
                    msg: 'Cadastrado com sucesso',
                    codigo: '201',
                    dados: {
                        idCargo: obj.insertId,
                        nomeCargo: cargo.nomeCargo
                    }
                };
                return response.status(201).send(resposta);
            }).catch(erro => {
                console.log(erro);
                const resposta = {
                    status: true,
                    msg: 'erro ao cadastrar',
                    codigo: '200',
                    dados: erro
                };
                return response.status(200).send(resposta);
            });
        }
        else {
            const resposta = {
                status: true,
                msg: 'Token Inválido',
                codigo: '200',
                dados: "erro"
            };
            return response.status(200).send(resposta);
        }
    }
}
exports.controle_create = controle_create;
