"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.controle_delete = void 0;
const Funcionario_1 = __importDefault(require("../../modelo/Funcionario"));
const JwtToken_1 = __importDefault(require("../../modelo/JwtToken"));
function controle_delete(request, response) {
    const dadosAutorizacao = request.headers.authorization;
    if (dadosAutorizacao !== undefined) {
        const jwt = new JwtToken_1.default();
        const validacao = jwt.validarToken(dadosAutorizacao);
        console.log(validacao);
        if (validacao.status == true) {
            console.log("validou toketn");
            let idFuncionario = parseInt(request.params.idFuncionario);
            const funcionario = new Funcionario_1.default();
            funcionario.idFuncionario = idFuncionario;
            funcionario.delete().then(value => {
                const obj = value;
                const resposta = {
                    status: true,
                    msg: 'Funcionario excluido com sucesso',
                    codigo: '201',
                    dados: {
                        idFuncionario: obj.insertId,
                    }
                };
                return response.status(201).send(resposta);
            }).catch(erro => {
                console.log(erro);
                const resposta = {
                    status: true,
                    msg: 'erro ao cadastrar',
                    codigo: '200',
                    dados: erro
                };
                return response.status(200).send(resposta);
            });
        }
        else {
            const resposta = {
                status: true,
                msg: 'Token Inválido',
                codigo: '200',
                dados: "erro"
            };
            return response.status(200).send(resposta);
        }
    }
}
exports.controle_delete = controle_delete;
