import { Request, Response } from "express";
import Funcionario from "../../modelo/Funcionario";
import JwtToken from "../../modelo/JwtToken";




export function controle_delete(request: Request, response: Response) {
  const dadosAutorizacao = request.headers.authorization;
  if (dadosAutorizacao !== undefined) {
   
    const jwt = new JwtToken();
    const validacao:any = jwt.validarToken(dadosAutorizacao);

    console.log(validacao);
    if (validacao.status == true) {
      console.log("validou toketn");

      let idFuncionario: number = parseInt(request.params.idFuncionario);
  
     
      const funcionario = new Funcionario();
      funcionario.idFuncionario = idFuncionario;

      funcionario.delete().then(value => {

        const obj: any = value;
        const resposta = {
          status: true,
          msg: 'Funcionario excluido com sucesso',
          codigo: '201',
          dados: {
            idFuncionario : obj.insertId,
          }
        };
        return response.status(201).send(resposta);

      }).catch(erro => {
        console.log(erro);
        const resposta = {
          status: true,
          msg: 'erro ao cadastrar',
          codigo: '200',
          dados: erro
        };
        return response.status(200).send(resposta);
      });

    }else{
      const resposta = {
        status: true,
        msg: 'Token Inválido',
        codigo: '200',
        dados: "erro"
      };
      return response.status(200).send(resposta);
    }
  }
}