"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.controle_login = void 0;
const Funcionario_1 = __importDefault(require("../../modelo/Funcionario"));
const JwtToken_1 = __importDefault(require("../../modelo/JwtToken"));
function controle_login(request, response) {
    const email = request.body.email;
    const senha = request.body.senha;
    const funcionario = new Funcionario_1.default();
    funcionario.email = email;
    funcionario.senha = (senha);
    funcionario.login().then((dados) => {
        //recebe a linha que veio do banco de dados
        const respostaLogin = dados[0];
        //verificar se qtd=1, e se o nome do cargo é admin
        //só é permitidor cadastrar cargos se a quantidade de usuarios com email e senha
        //for igual a um e se o cargo for admin
        if (respostaLogin.qtd == 1) {
            let usuario = {
                email: respostaLogin.email,
                nome: respostaLogin.nome,
                cargo: respostaLogin.nomeCargo
            };
            const jwt = new JwtToken_1.default();
            const novoToken = jwt.gerarToken(JSON.stringify(usuario));
            const resposta = {
                status: true,
                msg: "Login efetuado com sucesso",
                token: novoToken,
                funcionario: usuario
            };
            response.status(201).send(resposta);
        }
        else {
            const resposta = {
                status: false,
                msg: "Usuário não logado",
                codigo: 401,
            };
            response.send(resposta);
        }
    }).catch((erro) => {
        const resposta = {
            status: false,
            msg: 'erro ao executar',
            codigo: '005',
            dados: erro,
        };
        response.status(201).send(erro);
    });
}
exports.controle_login = controle_login;
