import { Request, Response } from "express";
import Funcionario from "../../modelo/Funcionario";
import JwtToken from "../../modelo/JwtToken";



export function controle_login(request: Request, response: Response) {


    const email = request.body.email;
    const senha = request.body.senha;

    const funcionario = new Funcionario();
    funcionario.email = email;
    funcionario.senha =(senha);

    funcionario.login().then((dados) => {
        //recebe a linha que veio do banco de dados
        const respostaLogin = dados[0];
        //verificar se qtd=1, e se o nome do cargo é admin
        //só é permitidor cadastrar cargos se a quantidade de usuarios com email e senha
        //for igual a um e se o cargo for admin
        if (respostaLogin.qtd == 1) {
          let usuario = {
            email: respostaLogin.email,
            nome: respostaLogin.nome,
            cargo:respostaLogin.nomeCargo
          }
          const jwt = new JwtToken();
          const novoToken = jwt.gerarToken(JSON.stringify(usuario));
  
          const resposta = {
            status: true,
            msg: "Login efetuado com sucesso",
            token: novoToken,
            funcionario: usuario
          }
  
          response.status(201).send(resposta);
        } else {
          const resposta = {
            status: false,
            msg: "Usuário não logado",
            codigo: 401,
          }
          response.send(resposta);
        }
  
      }).catch((erro) => {
        const resposta = {
          status: false,
          msg: 'erro ao executar',
          codigo: '005',
          dados: erro,
        }
  
  
  
        response.status(201).send(erro);
      });


}