"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.controle_update = void 0;
const Funcionario_1 = __importDefault(require("../../modelo/Funcionario"));
const JwtToken_1 = __importDefault(require("../../modelo/JwtToken"));
const Cargo_1 = __importDefault(require("../../modelo/Cargo"));
function controle_update(request, response) {
    const dadosAutorizacao = request.headers.authorization;
    if (dadosAutorizacao !== undefined) {
        const jwt = new JwtToken_1.default();
        const validacao = jwt.validarToken(dadosAutorizacao);
        // console.log(validacao);
        if (validacao.status == true) {
            //  console.log("validou toketn");
            const nome = request.body.nome;
            const email = request.body.email;
            const senha = request.body.senha;
            let vt = 0;
            if (request.body.vt == true) {
                vt = 1;
            }
            const idCargo = request.body.idCargo;
            const funcionario = new Funcionario_1.default();
            funcionario.idFuncionario = parseInt(request.params.idFuncionario);
            funcionario.nome = nome;
            funcionario.email = email;
            funcionario.senha = senha;
            funcionario.valeTransporte = vt;
            const cargo = new Cargo_1.default();
            cargo.idCargo = parseInt(idCargo);
            funcionario.cargo = cargo;
            funcionario.update().then(value => {
                const obj = value;
                const resposta = {
                    status: true,
                    msg: 'Funcionario atualizado com sucesso',
                    codigo: '201',
                    dados: {
                    // idFuncionario : obj.insertId,
                    }
                };
                return response.status(201).send(resposta);
            }).catch(erro => {
                console.log(erro);
                const resposta = {
                    status: true,
                    msg: 'erro ao cadastrar',
                    codigo: '200',
                    dados: erro
                };
                return response.status(200).send(resposta);
            });
        }
        else {
            const resposta = {
                status: true,
                msg: 'Token Inválido',
                codigo: '200',
                dados: "erro"
            };
            return response.status(200).send(resposta);
        }
    }
}
exports.controle_update = controle_update;
