"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Banco_1 = __importDefault(require("../modelo/Banco"));
class Cargo {
    constructor() {
        this._nomeCargo = "";
        this._idcargo = -1;
    }
    create() {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                const nomeCargo = this._nomeCargo;
                const PARAMETROS = [nomeCargo];
                const SQL = 'insert into cargo(nomecargo)values(?)';
                Banco_1.default.getConexao().query(SQL, PARAMETROS).then(([rows]) => {
                    resolve(rows);
                }).catch((erro) => {
                    reject(erro);
                });
            });
        });
    }
    read() {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                const PARAMETROS = [this._nomeCargo];
                const SQL = 'select * from cargo order by nomeCargo';
                Banco_1.default.getConexao().query(SQL, PARAMETROS).then(([rows, fields]) => {
                    // console.log(rows);
                    resolve(rows);
                }).catch((erro) => {
                    reject(erro);
                });
            });
        });
    }
    update() {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                const id = this._idcargo;
                const nomeCargo = this._nomeCargo;
                let PARAMETROS = [nomeCargo, id];
                let SQL = "update cargo set nomeCargo= ? where idCargo = ?";
                Banco_1.default.getConexao().query(SQL, PARAMETROS).then(([rows, fields]) => {
                    //console.log(rows);
                    return resolve(rows);
                }).catch((erro) => {
                    return reject(erro);
                });
            });
        });
    }
    delete() {
        return __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve, reject) => {
                let parametros = [this._idcargo];
                console.log("delete/" + this._idcargo);
                let SQL = "delete from cargo where idCargo=?";
                Banco_1.default.getConexao().query(SQL, parametros).then(([rows, fields]) => {
                    return resolve(rows);
                }).catch((erro) => {
                    return reject(erro);
                });
            });
        });
    }
    validarCargo() {
        if (this._nomeCargo == "") {
            return true;
        }
        return false;
    }
    get idCargo() {
        return this._idcargo;
    }
    set idCargo(id) {
        this._idcargo = id;
    }
    get nomeCargo() {
        return this._nomeCargo;
    }
    set nomeCargo(nome) {
        this._nomeCargo = nome;
    }
}
exports.default = Cargo;
