
import Banco from "../modelo/Banco";
import * as Mysql from 'mysql2/promise';

export default class Cargo {

  private _idcargo :number ;
  private _nomeCargo :string;
  
  constructor() {
    this._nomeCargo="";
    this._idcargo =-1;
  }

  public async create(): Promise<Mysql.RowDataPacket[]> {

    return new Promise<Mysql.RowDataPacket[]>((resolve, reject) => {
      const nomeCargo = this._nomeCargo;
      const PARAMETROS = [nomeCargo];
      const SQL = 'insert into cargo(nomecargo)values(?)'
      Banco.getConexao().query<Mysql.RowDataPacket[]>(SQL, PARAMETROS).then(([rows]) => {
          resolve(rows)
      }).catch((erro) => {
          reject(erro);
      });
    });

  }

  public async read(): Promise<Mysql.RowDataPacket[]> {

    return new Promise<Mysql.RowDataPacket[]>((resolve, reject) => {

      const PARAMETROS: string[] = [this._nomeCargo];
      const SQL = 'select * from cargo order by nomeCargo';
      Banco.getConexao().query<Mysql.RowDataPacket[]>(SQL, PARAMETROS).then(([rows,fields]) => {
       // console.log(rows);
          resolve(rows)
      }).catch((erro) => {
          reject(erro);
      });
    });

  }

  public async update(): Promise<Mysql.RowDataPacket[]> {
    return new Promise<Mysql.RowDataPacket[]>((resolve, reject) => {
      const id = this._idcargo;
      const nomeCargo = this._nomeCargo;

      let PARAMETROS = [nomeCargo, id];
      
      let SQL ="update cargo set nomeCargo= ? where idCargo = ?";
      Banco.getConexao().query<Mysql.RowDataPacket[]>(SQL, PARAMETROS).then(([rows, fields]) => {
        //console.log(rows);
         return resolve(rows)
        }).catch((erro) => {
          return reject(erro);
        });
    });

  }

  public  async delete(): Promise<Mysql.RowDataPacket[]> {
    return new Promise<Mysql.RowDataPacket[]>((resolve, reject) => {
      let parametros = [this._idcargo];
      console.log("delete/"+ this._idcargo);
      let SQL = "delete from cargo where idCargo=?";
      Banco.getConexao().query<Mysql.RowDataPacket[]>(SQL, parametros).then(([rows, fields]) => {
         return resolve(rows)
        }).catch((erro) => {
          return reject(erro);
        });
    });
  }


private validarCargo():boolean{
  if(this._nomeCargo==""){
    return true;
  }
  return false;
}

  
public get idCargo():number {
    return this._idcargo;
}

public set idCargo(id: number) {
    this._idcargo = id;
}

public get nomeCargo():string {
  return this._nomeCargo;
}

public set nomeCargo(nome: string) {

  this._nomeCargo = nome;
}
}
