fetch_graficos_get();

let eixoX = [];
let eixoY_qtdFuncionarios=[]
let eixoY_qtdValeTransporte=[]

function fetch_graficos_get() {
    const URI = "/funcionarios/graficos/";
    const operacaoAssincrona = fetch(URI, {
        method: "GET",
        headers: {
            'Accept': 'application/json',
            'Content-Type': 'application/json',
            //"Authorization": 'Bearer <' + TOKEN + '>',
        }
    });
    operacaoAssincrona.then((response) => {
        return response.text();
    }).then((jsonResposta) => {

        console.log("RECEBIDO:", jsonResposta);

        const objetoJson = JSON.parse(jsonResposta);
        montarVetores(objetoJson);
        gerararGrafico();

    });
    operacaoAssincrona.catch((error) => {
        console.error("Error:", error);
    });


}

function montarVetores(objetoJson){
 
    let i=0;
    for (let objeto of objetoJson.dados) {
        eixoX[i] = objeto.nomeCargo;
        eixoY_qtdFuncionarios[i] =objeto.qtdFuncionarios;
        eixoY_qtdValeTransporte[i] =objeto.valeTransporte;
        i++; 
    }
    
}
function gerararGrafico() {
    const ctx = document.getElementById('graficoBarros');
    new Chart(ctx, {
        type: 'bar',
        data: {
            labels: eixoX,
            datasets: [
                {
                    label: 'Quantidade de funcionarios',
                    data: eixoY_qtdFuncionarios,
                    borderWidth: 1,
                    //borderColor: '#FF6384',
                    //backgroundColor: '#FFB1C1',
                },
                {
                    label: 'Quantidade recebimento ValeTransporte',
                    data: eixoY_qtdValeTransporte,
                    borderWidth: 1,
                    //borderColor: '#FF6384',
                    //backgroundColor: '#FFB1C1',
                },
            ]
        },
        options: {
            scales: {
                y: {
                    beginAtZero: true
                }
            }
        }
    });
}