"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = require("express");
const controle_create_1 = require("../controlador/cargo/controle_create");
const controle_read_1 = require("../controlador/cargo/controle_read");
const controle_update_1 = require("../controlador/cargo/controle_update");
const controle_delete_1 = require("../controlador/cargo/controle_delete");
class CargoRoteador {
    constructor() {
        this._roteador = (0, express_1.Router)();
    }
    /**
     * configura as constroles para as respectivas rotas
     * exemplo de rota rota: GET: /cargos/
     */
    getRotasCargo() {
        // POST: /cargos/
        this._roteador.post("/cargos/", controle_create_1.controle_create);
        //GET: /cargos/
        this._roteador.get("/cargos/", controle_read_1.controle_read);
        //PUT: /cargos/
        this._roteador.put("/cargos/:idCargo", controle_update_1.controle_update);
        //DELETE: /cargos/
        this._roteador.delete("/cargos/:idCargo", controle_delete_1.controle_delete);
        return this._roteador;
    }
}
exports.default = CargoRoteador;
