import { Router } from "express";
import { controle_create } from "../controlador/cargo/controle_create";
import { controle_read } from "../controlador/cargo/controle_read";
import { controle_update } from "../controlador/cargo/controle_update";
import { controle_delete } from "../controlador/cargo/controle_delete";
export default
  class CargoRoteador {

  private _roteador = Router();

  /**
   * configura as constroles para as respectivas rotas
   * exemplo de rota rota: GET: /cargos/
   */
  public getRotasCargo(): Router {
    
    // POST: /cargos/
    this._roteador.post("/cargos/", controle_create);
     
    //GET: /cargos/
    this._roteador.get("/cargos/", controle_read);

    //PUT: /cargos/
    this._roteador.put("/cargos/:idCargo", controle_update);

    //DELETE: /cargos/
    this._roteador.delete("/cargos/:idCargo", controle_delete);
    return this._roteador;
  }
}
