"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = require("express");
const controle_login_1 = require("../controlador/funcionario/controle_login");
const controle_read_1 = require("../controlador/funcionario/controle_read");
const controle_create_1 = require("../controlador/funcionario/controle_create");
const controle_delete_1 = require("../controlador/funcionario/controle_delete");
const controle_getDadosGrafico_1 = require("../controlador/funcionario/controle_getDadosGrafico");
const controle_update_1 = require("../controlador/funcionario/controle_update");
class FuncionarioRoteador {
    constructor() {
        this._roteador = (0, express_1.Router)();
    }
    getRotasFuncionario() {
        this._roteador.post("/login", controle_login_1.controle_login);
        this._roteador.get("/funcionarios", controle_read_1.controle_read);
        this._roteador.post("/funcionarios", controle_create_1.controle_create);
        this._roteador.delete("/funcionarios/:idFuncionario", controle_delete_1.controle_delete);
        this._roteador.put("/funcionarios/:idFuncionario", controle_update_1.controle_update);
        this._roteador.get("/funcionarios/graficos", controle_getDadosGrafico_1.controle_getDadosGrafico);
        //this._roteador.get("/funcionarios", controle_read);
        // this._roteador.put("/funcionarios", controle_read);
        //this._roteador.delete("/funcionarios", controle_read);
        return this._roteador;
    }
}
exports.default = FuncionarioRoteador;
