import { Request, Response } from "express";
import Cargo from "../../modelo/Cargo";
import JwtToken from "../../modelo/JwtToken";



export function controle_create(request: Request, response: Response) {
  const dadosAutorizacao = request.headers.authorization;
  if (dadosAutorizacao !== undefined) {
   
    const jwt = new JwtToken();
    const validacao:any = jwt.validarToken(dadosAutorizacao);

    console.log(validacao);
    if (validacao.status == true) {
      console.log("validou toketn");
      const nomeCargo: string = request.body.nomeCargo;
      const cargo = new Cargo();
      cargo.nomeCargo = nomeCargo;

      cargo.create().then(value => {

        const obj: any = value;
        const resposta = {
          status: true,
          msg: 'Cadastrado com sucesso',
          codigo: '201',
          dados: {
            idCargo: obj.insertId,
            nomeCargo: cargo.nomeCargo
          }
        };
        return response.status(201).send(resposta);

      }).catch(erro => {
        console.log(erro);
        const resposta = {
          status: true,
          msg: 'erro ao cadastrar',
          codigo: '200',
          dados: erro
        };
        return response.status(200).send(resposta);
      });

    }else{
      const resposta = {
        status: true,
        msg: 'Token Inválido',
        codigo: '200',
        dados: "erro"
      };
      return response.status(200).send(resposta);
    }
  }
}