import { Request, Response } from "express";
import Funcionario from "../../modelo/Funcionario";
import JwtToken from "../../modelo/JwtToken";
import Cargo from "../../modelo/Cargo";



export function controle_create(request: Request, response: Response) {
  const dadosAutorizacao = request.headers.authorization;
  if (dadosAutorizacao !== undefined) {
   
    const jwt = new JwtToken();
    const validacao:any = jwt.validarToken(dadosAutorizacao);

    console.log(validacao);
    if (validacao.status == true) {
      console.log("validou toketn");

      const nome: string = request.body.nome;
      const email: string = request.body.email;
      const senha: string = request.body.senha;
      
      let vt: number = 0;
      if(request.body.vt==true){
        vt=1;
      }
      const idCargo: string = request.body.idCargo;
      console.log(request.body);

      const funcionario = new Funcionario();
   
      funcionario.nome = nome;
      funcionario.email = email;
      funcionario.senha = senha;
      funcionario.valeTransporte= vt;  

      const cargo = new Cargo();
      cargo.idCargo = parseInt(idCargo);

      funcionario.cargo = cargo;

      funcionario.create().then(value => {

        const obj: any = value;
        const resposta = {
          status: true,
          msg: 'Cadastrado com sucesso',
          codigo: '201',
          dados: {
            idFuncionario : obj.insertId,
            nome: funcionario.nome,
            email:funcionario.email,
            recebe_valeTransporte:funcionario.valeTransporte,
            idCargo: cargo.idCargo

          }
        };
        return response.status(201).send(resposta);

      }).catch(erro => {
        console.log(erro);
        const resposta = {
          status: true,
          msg: 'erro ao cadastrar',
          codigo: '200',
          dados: erro
        };
        return response.status(200).send(resposta);
      });

    }else{
      const resposta = {
        status: true,
        msg: 'Token Inválido',
        codigo: '200',
        dados: "erro"
      };
      return response.status(200).send(resposta);
    }
  }
}